eMill release notes:

Bug fixes/Changes in v5.29.78 (26-Jan-2026)
- New: Possibility to open an external EML file in eMill through the classic File/Open menu.
- New: Added the "real" disk usage of project files in the queue project list view.
- New: Added a Copy command to the receivers list and black list context menus to copy the cell
      value to the clipboard.
- Enhanced: Possibility to quickly view the MIME source of a message when it is opened in the
            queues, through the Ctrl+H/Ctrl+U keyboard shortcut.
- Enhanced: When eMill receives an email with a subject that is not correctly encoded, eMill will
            use the first charset found in the message body to decode the subject. This is the
            default behavior of most email clients.
- Fixed: Reinstallation of eMill was failing if the eMill Server service was configured to run
         under a specific user account (different from the system account).
- Fixed: Regression: EWC failed to install every two installations.
- Fixed: The EWC site was returning an error in some specific installation cases.
- Fixed: Regression from v5.28.76: French and German languages were no longer available in the
         eMill Web Client interface.
- Updated: SQLite v3.51.2

Bug fixes/Changes in v5.28.76 (26-Nov-2025)
- New: Added a context menu entry on project content to duplicate the content.
- New: Added a context menu entry in the project sidebar to edit the project properties.
- Improved: eMill binaries, including setup files, are now signed.
- Fixed: Refresh of XML receivers or blacklists was not always working.
- Fixed: Crash in DKIM signature verification.
- Updated: SQLite v3.50.4
- Updated: MySQL library v5.7.44
- Updated: Compiled with the latest C++ compilers (Visual Studio 2022).
- Removed: Tracking redirector for Windows 2000/XP/2003.
- Removed: Fax channel option.

Bug fixes/Changes in v5.25.73 (01-Aug-2023)
- Enhanced: Use TLS up to the latest v1.3 on SMTP secure connections, achieve top-tier security
            and swift performance.
- Enhanced: When a datasource uses a MySQL ODBC driver not present on the machine, but another
            version is installed, the datasource falls back to the more recent installed MySQL ODBC
            driver if possible.
- Fixed: The incoming message rule action 'Call a web site' could fail if the headers copied
         from MIME to HTTP request contained non ASCII characters.
- Updated: SQLite v3.42.0
- Updated: libdkim v1.0.21
- Updated: OpenSSL v1.1.1u

Bug fixes/Changes in v5.24.72 (21-Mar-2022)
- Enhanced: Better detection of EML files when drag & dropping a file in the queues.
- Enhanced: A double click on a disconnected server from the queues initiate a reconnection.
- Enhanced: Use HTTPS protocol to communicate with our spam checker web service.
- Fixed: Addresses in email viewer where truncated if a display name was present.
- Fixed: Scheduling could sometime start at the wrong time due to daylight saving time setting.
- Fixed: In incoming message processor, the text body was sometime used instead of the HTML body in
         search condition or in the web page call action.
- Updated: SQLite v3.38.0

Bug fixes/Changes in v5.23.71 (16-Oct-2020)
- New: Emails opened from the queues are now displayed by default in the eMill internal email
       viewer instead of the default mail client application. Email can still be opened with
       the system mail client by clicking the 'Open with' toolbar button.
- New: Support for MySQL ODBC driver 8.0
- Fixed: On folder compact, some part of email headers could be ignored and not imported properly.
- Updated: SQLite v3.33.0
- Updated: OpenSSL v1.0.2u

Bug fixes/Changes in v5.22.70 (03-Mar-2020)
- Fixed: eMill account can now contain the - and _ character.
- Fixed: Images in Thunderbird could sometime be corrupted when a complex URL was used.
- Fixed: When adding a CSV or TXT receivers list, the selection of the column that contains
         email was sometimes wrong.
- Fixed: Unicode encoded CSV or TXT receiver list files are now properly handeled.
- Enhanced: Embedded contents now have their original filename stored allowing mail clients
            to offer a better 'Save As' default filename.
- Updated: SQLite v3.31.1

Bug fixes/Changes in v5.22.69 (01-Mar-2019)
- New: The "Forward message" as a new option to forward the message with a Reply-To attribute. When set,
       the message original From field is replaced by the project From field value, and the Reply-To
       field is set to the original From field. This is to avoid SPF protection failures.
- Fixed: The JSON object was not available in global script rendering events.
- Fixed: EMLs files were truncated when dragged from eMill queues to a Windows explorer folder.
- Enhanced: Importation of non MIME files to a queue folder embeds the file into a MIME content.
- Enhanced: Improved EMLs drag & drop from the queues with Firefox, Thunderbird and Chrome.
- Enhanced: Clicking on links in the message preview window now opens the page in the default browser.
- Updated: SQLite v3.27.2

Bug fixes/Changes in v5.21.68 (25-Sep-2018)
- New: An incoming message rule can post a body or attachment to a web server
- New: Possibility to access Mailing.ConnectString sub parts (Mailing.ConnectString("password") for example)
- New: StrToMultibyte AMS function to convert a string as a multi byte array
- Enhanced: The AMS GetHttpFile function can now post raw data if given a byte array "field" parameter
- Enhanced: The AMS GetHttpFile function throw the server HTTP status on error instead of a generic error
- Fixed: DKIM validation could fail in some cases (when DKIM public record was split in several chunk)
- Fixed: CSafeStr function could fail to convert a byte array as a string
- Fixed: JSON object was not available in global script events
- Updated: SQLite v3.25.1
- Updated: EWC: FreeTextBox updated to v3.3
- Updated: OpenSSL v1.0.1u

Bug fixes/Changes in v5.20.67 (17-Oct-2017)
- New: Web API that allows managing published projets
- Changed: EWC: Max file upload size changed from 20MB to 100MB.
- Changed: Use the newer Microsoft ACE database provider (if installed) instead of Jet when adding an XLS
           receivers or black list. This fixes an Unspecified error on list opening due to a Windows update.
- Fixed: Incoming SMTP could stop working in some cases.
- Fixed: JSON sub objects returned by JSON.parse could not be enumerated using the For Each statement.
- Fixed: Return a more explicit message than 'invalid pointer' on unsupported SOAP response.
- Updated: SQLite v3.20.1
- Updated: Support for MySQL ODBC driver 5.3

Bug fixes/Changes in v5.19.66 (10-Apr-2017)
- New: SMTP incoming queues. eMill acts as a real delivery SMTP server, received
       messages are stored in the project Inbox folder.
- New: Message Rules: It is now possible to extract an email address from any text
       in the message body. The first one found is returned.
- New: Message Rules: It is now possible to check file attachment types (eg. can
       filter dangerous attachments).
- New: Message Rules: Support for Google specific DSN messages (bounces).
- New: Scripting: Added Mailing.ClearLog method.
- New: Scripting: Added Crc32 and Md5 global script functions.
- New: Added 'Copy From Address' and 'Copy To Address' contextual menu to a message
       item in the queues.
- Fixed: Multiline response during SMTP protocol exchange are now entirely saved
         in message receiver status.
- Fixed: Aborted message diagnostic could be wrong in some rare cases (SMTP response
         with non ASCII values caused encoding problem).
- Fixed: EWC: Statistics could be displayed truncated due to a bug in the stat start date
         computation (local time to UTC convertion missing).
- Fixed: When scheduling a project, the user right 'Logon on as a batch job' is automatically
         added to the user to avoid silent failures.
- Fixed: Pasting of text containing only a LF or CR char as line separator was not working
         properly in the eMill text editors. 
- Updated: SQLite v3.18.0
- Updated: wktmltopdf v0.12.4

Bug fixes/Changes in v5.18.65 (14-Dec-2016)
- Fixed: Possible memory corruption when pasting long lines in the text editor.
- Fixed: HtmlToText() now correctly handles hexadecimal HTML entities.
- Fixed: Regression from v5.17.64: Reply-To field was no longer set in the final sent MIME.
- Enhanced: HTML entities are decoded for the FullName, FirstName, LastName and EmailAddress
            properties of the Record object.
- Enhanced: HTML entities are decoded in the final MIME To field.
- Enhanced: Projects are automatically opened once downloaded from the Queues.

Note: HTML entities are not supposed to be in database records but in practice they often are, 
      eMill now decodes these fields so that MIME headers fields are cleaner.
       
Bug fixes/Changes in v5.17.64 (23-Nov-2016)
- New: Scripting: Added a Mail.ReplyTos collection to handle the Reply-To header field.
- Fixed: Scripting: GetHttpFile returns JSON file as a string value (and no longer as a byte array)
         so that the JSON data can be parsed with JSON.Parse.
- Updated: OpenSSL 1.0.1t, (misc security fixes).
- Updated: SQLite v3.15.1 (lots of performance improvements).
- Updated: wktmltopdf v0.12.3.2

Bug fixes/Changes in v5.16.63 (11-Apr-2016)
- Fixed: Add X-Sender field to incoming message, extracted from the From field. This field is required
         when forwarding an email.
- Fixed: Random crash when sending messages using SSL/TLS SMTP connections.
- Updated: SQLite v3.12.0

Bug fixes/Changes in v5.16.62 (30-Dec-2015)
- Updated: OpenSSL 1.0.1q, fixes some eMill server locks while sending using SSL/TLS SMTP connections.
- Updated: SQLite v3.9.2
- Updated: MySQL library v5.7.9
- Fixed: ASPX redirector could not redirect to the root page of the web site on which it is installed.
- Fixed: EWC: Server time could be wrong on schedule page when using IE or Chrome.
- Fixed: Misc UI fixes.

Bug fixes/Changes in v5.16.61 (29-Jul-2015)
- New: JSON scripting object.
- New: Support for Office 2013 format using the ACE 15 OLEDB provider if installed.
- Enhanced: PDF conversions are now performed using the wkhtmltopdf tool. This tool works on any
            Windows platform, is faster and supports parallel rendering.
- Enhanced: When X-Href-Prefix or X-Href-Suffix are specified, the addition of prefix or suffix
            is now done in a smarter way (prefix is prepended with URL encoded link and suffix
            is correctly merged to query string if it begins with ? or &).
- Enhanced: Added charts for clicks and opens per days/hours to PDF export.
- Fixed: eMill server now cleans previously imported temporary databases at startup.
- Fixed: EWC: Rendering could fail with the 'A database already exists' error when using many
         'imported' data source (Related to eMillConnector).
- Fixed: EWC: Could display the server time using a wrong locale (if computer was in German and
         browser in English for example).
- Fixed: Directly aborted messages were not accounted for in the Send statistics.
- Updated: SQLite v3.8.10.2
- Updated: OpenSSL v1.0.1l (misc security fixes).

Bug fixes/Changes in v5.15.60 (3-Dec-2014)
- New: Support for Amazon SNS email delivery notifications.
- New: Subscribed incoming and outgoing queues are now displayed in the projects queue view.
- Fixed: EWC: Some erroneous German translations.
- Fixed: Possible server lock during eMill Server service shutdown.
- Fixed: The LC+ datasource wizard was not retreiving correctly the hotspot portals list.
- Fixed: Warning message no longer displayed during the publish process if the project folder contains a Thumbs.db locked file.
- Fixed: Some DSN email addresses where not correctly extracted during incoming message processing.
- Fixed: Schedule time could be reported incorrecly in EWC and win32 client if the time at the
         schedule starting date was different than current time (due to a daylight saving time change).
- Fixed: DKIM signature errors are correctly reported to the message status headers.
- Enhanced: Added a debug log to help troubleshoot server startups. 
- Updated: SQLite v3.8.7.2
- Updated: OpenSSL v1.0.1j (misc security fixes).

Bug fixes/Changes in v5.14.59 (14-Apr-2014)
- New: Added a Trim property to the Record object to enable or disable automatic field values trimming.
- New: Outgoing queues settings are now saved as file in the config folder. They were previously
       saved in the registry.
- Fixed: EWC: When saving a scheduled task, the task time was reloaded with an incorrect value.
- Fixed: EWC: Schedule page could sometime display a JavaScript alert.
- Fixed: When adding a data source file to a network drive located project, the data source path
         is no longer changed to a UNC path, but to a project relative path.
- Fixed: Resuming a render on a message store that is not of SQLite type was sometime failing
         and also very slow.
- Fixed: Statistics could be erased when compacting a project.      
- Fixed: HTTP linked contents of POST type were cached when they should not. This resulted in
         sending the wrong content.
- Updated: SQLite v3.8.4.1.
- Updated: OpenSSL v1.0.1g (not vulnerable to HeartBleed vulnerability).

Bug fixes/Changes in v5.13.58 (25-Sep-2013)
- New: Add the possibility to specify the PDF margin and orientation through scripting.
- New: EWC: Added url login support to authenticate the web client.
- Fixed: Force the user to enter a password when changing the schedule page otherwise the operating
         system silently discard the modification.
- Fixed: Error "Invalid argument" was sometime returned instead of "HTTP Error 401: Authorization required"
         during http requests (linked content, soap, etc.).
- Fixed: eMill Server crash under heavy receiving queues load.
- Fixed: Small memory leak when sending messages through an authenticated SMTP session.
- Fixed: Poor sending performances when sending lots of messages and using SQL Server 2008.
- Fixed: EWC: HTML editor was broken with IE 10.
- Enhanced: Minor performance improvements of the SQLite store backend under heavy loads (render/send/receive/processing).
- Enhanced: Incoming queues processing performance improvement on multi-CPU systems.
- Updated: MySQL library v5.6.12
- Updated: SQLite v3.8.0.2

Bug fixes/Changes in v5.12.57 (28-Mai-2013)
- New: EWC: Added full support for Windows 8
- New: 'Is anniversary' data source filter on date columns.
- New: Data source wizard to extract LC+ hotspot users.
- New: Added support for MySQL ODBC connector v5.2.
- Fixed: Header field To, From, CC or Reply-To were not correctly encoded if the display name 
         part of the address contained a coma (,) character.
- Fixed; When a first list was added to an empty project, its records contents were empty when previewing
- Updated: SQLite library updated to v3.7.17

Bug fixes/Changes in v5.11.56 (13-Dec-2012)
- New: It is now possible to configure a project not to render messages for a 
  receiver when an existing message for the same receiver is present in the 
  Outbox or Sent folder.
- New: The email address verfification feature can now export to a CSV file.
- Fixed: Avoid ASPX redirector to dump an exception page on some malformed tracked links.
- Fixed: EWC: pixi datasource wizard could fail return to lists pages in some cases.
- Fixed: A security warning was displayed on preview when IE9 was installed.
- Fixed: Links within merge fields were not correctly encoded.
- Fixed: Crash with MySQL message store backend when performing operation on a 
  multiselection of messages.
- Updated: SQLite library updated to v3.7.14.1

Bug fixes/Changes in v5.10.55 (23-May-2012)
- New: PDF convertion is now available on Windows Vista/7/2008 and x64 editions
- Enhanced: Improved PHP redirector compatibility with old PHP versions.
- Enhanced/Fixed: Use a fixed list of well-known content types associated with file extensions
                  to avoid some content types to be incorrectly guessed depending on what is
                  registered on the computer. As a side effect, this should speed-up rendering
                  because for each well known association, no content sniffing will occur...
- Fixed: Race condition that could cause eMill server to crash or lock.
- Fixed: Bug in URL tracking compression algorithm that caused a few corrupted links.
- Fixed: Content were not correctly named when creating a project from a template, and an
         x-content-name attribute was left in the content-type.
- Updated: SQLite library updated to v3.7.11

Bug fixes/Changes in v5.9.54 (04-Nov-2011)
- New: Mail.Fields collection. See the scripting Help file for details.
- Improved: Mailing.CreateMail and Mailing.SubmitMail can now be called within Mailing_OnUrlClicked()
- Changed: Duplicate Project As default parent folder is now the same as the duplicated project.
- Fixed: EWC: First message sent date was displayed in UTC in statistics instead of local time.
- Fixed: The ASPX redirector could store opens an clicks time with a 12 hours shift error.
- Fixed: URL were not tracked correctly if the URL contained a comma.
- Fixed: Delivery Status Messages were not sent to the inbox when using the built in SMTP delivery agent.
- Updated: SQLite library updated to v3.7.8


Bug fixes/Changes in v5.8.53 (28-Apr-2011)
- New: Text based merge field syntax {Field} is now supported in any kind of text or html content.
- New: IsJokerMatch() global script helper function.
- New: The .Net ASPX redirector can redirect to a default URL if called with an invalid URL.
- New: The pixi* data source wizard now has a namespace parameter.
- New: Http linked contents can now include AMS scripts.
- Improved: The 64 bit version (available as a beta) now supports Microsoft Access, Microsoft
            Excel and text data sources using the x64 ACE 12 provider.
- Fixed: EWC: Openings and clicks are no longer exportable if openings and clicks tracking
              options are not enabled.
- Fixed: EWC: It was not possible to log on using a non admin user account if eMill was installed
              on a domain controller.
- Fixed: EWC: Log changes were not notified and its content wasn't reloaded automatically.
- Fixed: EWC: Preview navigation is no longer broken if a rendering error occurs.
- Fixed: EWC: Shared list records could not be updated if they contained a read only field (e.g.
              a primary key).
- Fixed: EWC: Add/Remove column was sometimes failing due to the database being locked.
- Fixed: It was sometime not possible to navigate back in the datasource wizard.
- Fixed: Messages that contained a line with only one dot were in some case sent truncated.
- Fixed: Significantly improved eMill Server performances when hundreds of projects are published.
- Fixed: The eMill Server service can now be correctly stopped if it was in a paused stated.
- Changed: OpenSSL library updated to v1.0.0d
- Changed: SQLite library updated to v3.7.6

Bug fixes/Changes in v5.7.52 (14-Fev-2011)
- New: Completely redesigned the message tracking feature:
    * Now uses natural URLs (using the URL rewriting technology, requires IIS 7 or Apache 2).
    * Supports multiple redirectors (you can have one redirector for one or more domains).
    * URLs are shorter (15% on average).
    * Improved Linux support thanks to the PHP version (the redirector is far more easy to
      install than the C language version).
    * Now works on Windows Server 2008 or better (IIS 7).
- New: Merge field support in HTML URLs.
- New: DecodeInternetDate global script helper function.
- Improved: More non standard bounces are accounted for in the bounce statistics (still
            not perfect however).
- Enhanced: Include message fields in exported clicks.csv. This is redundant, but a lot of customers
            have asked for this 'feature' (because it's hard to perform a table join on csv files).
- Changed: Response.Write no longer fails if passed a null or an empty parameter.
- Changed: The DKIM config file is now stored in \config folder instead of the \bin folder.
- Fixed: EWC: Filtering on a date field in the statistics was not working.
- Fixed: Some character encoding issues using the URLEncode API. Furthermore, a charset can
         be specified so that strings are first converted to the given charset before the URL
         encoding.
- Fixed: Filtering was always disabled for shared list in eMill win32 UI.         

Bug fixes/Changes in v5.6.51 (29-Nov-2010)
- Enhanced: When user add a content from file and this file is already referenced by another
            content, eMill prompts a warning that offers to duplicate the file.
- Enhanced: Significant performance improvements on servers with hundreds of published eMill
            projects.
- Fixed: A POP3 queue could stay locked while waiting for some remote server data.
- Fixed: Sending to a receiver that had a + sign in it's email address was failing if the
         remote SMTP server supported the DSN extension.
- Fixed: The Record object was not always available when the Mailing_OnUrlClicked() event was
         triggered.
- Fixed: EWC: Creation of a black list using a shared list could fail with a "sqlQuery null"
         error.

Bug fixes/Changes in v5.6.50 (22-Sep-2010)
- New: Built-in outgoing queues can now use secure SMTP connection when available.
- New: SQLite data source support through its ODBC driver (if present). Record deletion and
       modification is enabled only if an 'auto unique' column is found since the ODBC driver
       doesn't support updates/deletes regarding cursor position.
- New: A 'Stop Compact' command was added to cancel a compact operation. 
- New: EWC: Registry value FormAuthentication that allows to disable EWC form authentication if
       set to 0.
- Improved: EWC: HTML editor now works with Chrome and Safari browsers (FTB 3.2.4).
- Improved: When the data source wizard is called from the list properties, the current list
            settings are preloaded in the wizard when possible.
- Improved: Native ODBC datasource support is faster and more robust.
- Fixed: When using a FileMaker data source, the tables were not displayed.
- Fixed: Mailing projects where not shown when the user only had the 'view statistics' right.
- Fixed: EWC: data source wizard now uses MyODBC 5.1 if MyODBC 3.51 is not installed.
- Updated: OpenSSL v1.0.0a (security fix).

Bug fixes/Changes in v5.5.49 (20-May-2010)
- New: POP3 incoming queues can now be used over SSL.
- New: SMTP outgoing queues can now be used over SSL/TLS.
- New: Support for the 'Personal Edition'.
- Fixed: Dots which are located at the beginning of a line are now correctly removed from received
         messages, as specified by the RFC1939. 
- Fixed: Paste in grid control was broken when the inner edit control didn't have the focus.
- Fixed: Regression: Opening a large list could take a very long time.
- Changed: The Save project from queues dialog defaults to eMill projects folder.
- Enhanced: Added a cache to store HTTP images during the rendering process.

Bug fixes/Changes in v5.4.48 (29-Jan-2010)
- New: List can now be defined and shared at the eMill Server level for eMill Clients to use.
- New: The new receivers list wizard now has a SQL Server dedicated page.
- Improved: Added an option to save the default MySQL server connection settings.
- Improved: EWC: The ecommerce pixi* wizard has been completely redesigned.
- Improved: Received messages have a new header indicating the incoming queue name.
- Improved: The eMill installer now uses the 7zip (LZMA) compression which explains why this new
            version is much smaller to download.
- Fixed: The Microsoft VC++ redistribuable setup is now embedded in the eMill setup package in
         order to fix various installations problems.
- Fixed: Problem when connection to Access Databases when Windows was in the German language.
- Fixed: The HTML editor colour selection menu was always disabled.
- Fixed: All sent messages were exported in the 'Opens' csv export, not just the opened ones.
- Fixed: The message bounce count was wrong if sent messages where deleted right after sending them.

Bug fixes/Changes in v5.3.47 (11-Dec-2009)
- Fixed: The bounce count was set to 0 in the domain details statistics report.
- Fixed: Out of memory problem in statistics report with large results.
- Fixed: Statistics were randomly lost when processing a lot of incoming messages.
- Fixed: Statistics filters were not always used.
- Fixed: Statistics filters are no longer lost when switching between pages.
- Fixed: EWC: XML wizard was no longer working.
- Fixed: Crash when adding a list to a remote project.
- Fixed: In somes cases, the pack project option could cause a server dead lock.
- Fixed: Some incoming messages could lock the incoming queue.
- Fixed: The anti spam checker could timeout when a message was too large.

Bug fixes/Changes in v5.3.46 (21-Sep-2009)
- Fixed: The HTML editor was breaking HTML source and the message preview when Windows update
         KB956844 was installed. 
- Fixed: From the Queues, the 'Save As' context menu was always disabled on messages.
- Fixed: The Foxmail mail client software did not display messages properly when started from the
         eMill message preview.
- Added: Possibility to install the EWC on Win2003 x64 if IIS is already installed and if IIS 32bit
         mode is enabled.
- New: 'Add to blacklist' option from the receivers list.
- Improved: Support for Microsoft Office 2007 Access and Excel files in the data source wizard.
- New: EWC: Possibility to filter statistics on attached fields.
- Improved: The pixi* wizard was greatly improved.
- Improved: Export dialog now allows to export whitelisted or blacklisted addresses
- Improved: Various cosmetic changes.

Bug fixes/Changes in v5.2.45 (8-Jun-2009)
- New: DKIM signature support (DomainKeys Identified Mail)
- New: Message drag & drop support in the queues
- New: Mechanism to keep connection alive between eMill Client and eMill Server
- New: Save command to copy published mailings locally
- New: Display CC and Reply-To fields in message preview when these fields are not empty
- Improved: Accounting database now uses SQLite.
- Fixed: Rename a published project with a same name but a different case is now working
- Fixed: EWC: Html editor was not working under IE 8
- Fixed: Regression from v5.0, delete rendered messages when aborting a render was no longer
         working if the user was not an administrator of the machine 
- Fixed: Invalid parameter error when trying to browse for an user in redirector property page
- Fixed: Invalid sending performance count
- Fixed: Black list verification was not working

Bug fixes/Changes in v5.1.44 (03-Feb-2009)
- New: The installation of the eMill Web client server component is now possible on Windows Vista,
       Windows 2008 and Windows 7, for both 32 bits and 64 bits architecture.
- New: An aborted render can now be resumed depending on the user's choice.
- New: An abort error ratio threshold can set to avoid render failures when only a few receivers
       have failed.
- Improved: The list properties dialog is now opening much faster when using an ODBC MySQL data
            source.
- Improved: eMill uses MyODBC 5.1 if MyODBC 3.51 is not installed.
- Improved: Render error reporting has more details (email, list and position are displayed in the
            error log).
- Improved: EWC: The displaying of a remote list is much faster.
- Fixed: In some rare case the messages database could crash and take a very long time to repair.
- Fixed: EWC: The redirect messages feature was no longer working since v5.0.
- Fixed: EWC: Record based message rules could throw an error when changing the data source.
- Fixed: EWC: "Received date and time schedule" condition rule was not working due to a java script
         error.
- Fixed: EWC: Some samples would not open correctly.
- Fixed: In some rare cases, the tracking redirector was truncating links.
- Fixed: Local images where not embedded if their path was URL encoded.
- Fixed: Local images with % in the file name were not correctly added from the HTML editor UI
         (images were broken or missing).
- Fixed: Various cosmetic bugs and optimizations in the Win32 and Web client.

Bug fixes/Changes in v5.0.43 (01-Dec-2008)
- New: Completely redesigned message store that supports SQL Server, MySQL and SQLite enabling
       extra robustness and flexibility.
- New: Completely redesigned message tracking user interface
- New: Ability to rename a published mailing
- New: Outgoing queues can now be specified for a project or a user account
- New: You can import messages inside a queue folder
- New: Tracked links can now be activated on a per link basis
- New: HTML body contents now have an option to auto-generate the alternative text part without
       having to create a body text content
- New: The default user project folder can now be pre defined.
- New: Accounts can be remotely managed from the Queues
- Improved: Test messages can now be sent using a specific eMill server and outgoing queue
- Improved: eMill windows now records the column size and order in queue views
- Improved: Icons were updated and are now the same between the web and Windows interface
- Improved: Finer grain control on outgoing queues (IP binding, max messages per session...)
- Improved: When receiving a DSN message, the original message is automatically moved to the
            aborted folder and the diagnostic code information is displayed.
- Fixed: XML provider could return invalid HTTP errors descriptions
- Fixed: The sending process could stop working and an eMill Server  service restart was necessary
- Fixed: The Opt-in wizard was not working when using the German language

Bug fixes/Changes in v4.6.42 (23-Nov-2007)
- New: EWC: Login/logout feature
- Improved: EWC: The 'New Content' wizard can now add contents located on a network folder
- Improved: EWC: Receivers list may now be located on a network folder
- Improved: EWC: Personalized contents can now be downloaded directly through the interface
- Improved: EWC: When a contact list with attached rules is renamed, the application is able to
            rename the rules with the new contact list name
- Improved: EWC: When a contact list with attached rules is deleted, the application is able to
            delete the rules where the contact list appeared
- Fixed: DSNs generated by eMill builtin server did not have a Message-ID header field
- Fixed: eMill server could crash when saving a project
- Fixed: Disabled linked contents could cause an error during the preview and render
- Fixed: 'Add date and time to project log events' option was always shown as not enabled even if
         the option was enabled
- Fixed: Column deletion did not work on SQL Server contact lists
- Fixed: EWC: An "Invalid object name 'all_columns' open" message was displayed when adding an ODBC
         SQL Server contact list
- Fixed: EWC: Regression where import could not be performed if the Fax module was not installed
- Fixed: EWC: Starting the mailer and render could display a "Thread was being aborted" message
- Fixed: EWC: Regression where filters applied on tracking interface did not work

Bug fixes/Changes in v4.5.41 (10-Aug-2007)
- New: Anti spam checking feature that lets you analyze your mail content directly from the eMill
       preview
- New: Support for the connection to the eMill Optin service subscribers list. Check
       http://optin.emill.net/service/ for details
- New: Support for the connection to Mad Geniuses Pixi SOAP data sources
- New: Soap object that lets you call web services using the eMill scripting interface
- New: Support for the Chinese GB18030 charset 
- Improved: The XML connector now supports .Net dataset xml files
- Changed: The Reset Tracking statistics user right is no longer linked to the Create Project right
- Improved: The list view and queue folder views can be unsorted (3rd click on the same column)
- Fixed: The XML connector was deleting the XML source file if the file was local
- Fixed: Could not delete the tracking statistics (regression)
- Fixed: The tracking database was not always created on Windows 2000 systems
- Fixed: Crash when compressing to zip or converting to pdf a multi file content
- Fixed: The Fax SMTP forwarding feature was not working if the forward From or To address
         contained a display name
- Fixed: Some memory leak in the XML connector
- Fixed: From the preview, the right click 'Copy to clipboard' command was no longer working
         (regression)
- Fixed: EWC: Zero length files can now be uploaded.
- Fixed: EWC: A record can now be previewed from the list when the listed is sorted.
- Fixed: EWC: When deleting a column that is bound to a special field, the unbound was not
         performed automatically.
- Fixed: EWC: The Footer was not always correctly displayed in Internet Explorer 7.
- Fixed: EWC: Some Microsoft Access data types were not handled properly.
- Fixed: EWC: When using an Excel list, verify addresses and check duplicates are now available for
         edit only (delete is no longer possible since it was not supported by the underlying
         database driver)
- Fixed: EWC: When a relative image was added to an HTML content, the image was not displayed.
- Fixed: EWC: Scheduled actions were set in UTC time instead of Local time, therefore scheduled
         actions were executed at the wrong time.

Bug fixes/Changes in v4.4.39 (3-May-2007)
- New: eMill Client is now compatible with Windows Vista
- New: Personalized attachments for each receiver can now be added without the requirement of scripting
- New: A project and its associated files may now be deleted directly from the eMill design mode
- New: 'Paste Special' menu command that lets you clean up pasted HTML (e.g. clean up MS Word html)
- New: GetHttpFile script function
- Improved: Linked content can now be stored on an http source which requires authentication (login, password)
- Improved: A 'Call URL' incoming rule can now call an http source which requires authentication (login, password)
- Improved: The new content wizard was improved and is more user friendly
- Fixed: Support of the PostgreSQL ODBC driver (table list and import was not working)
- Fixed: Database Type conversions in message rules are more robust (better support for GUID, BOOL, etc.)
- Fixed: Memory leak when pasting HTML copied from the eMill HTML editor.
- Fixed: Images with scripted url were displayed has a broken image in content edition. Now an image overlaid with an exclamation mark is displayed.
- Fixed: eMill server was using 100% CPU if a tracking log was corrupted ('\0' char inside)
- Fixed: If a project path contained non Ansi characters, local images were not be embedded
- Fixed: EWC: If a user clicked on the Help button in 'Check addresses', the system displayed an error
- Fixed: EWC: Bug in the rules UI, the test condition was always set to 'if one condition matches'
- Fixed: EWC: server side script in <a href> attribute was corrupted when switching between html and design view
- Fixed: Message body disposition was correctly saved for linked content, but was not correctly reloaded in the property page (inline was selected)
- Fixed: Pausing the eMill server service was not possible
- Fixed: The eMill server service was preventing some laptop to enter the stand by or hibernate mode
- Fixed: Email addresses were not saved in the account properties
- Fixed: The setup program did not set the thread count correctly for the outgoing queues (/thread instead of /threads)
- Fixed: In the task scheduler, the Thursday check box was never checked
- Fixed: The start page was displayed after the splash screen if eMill was launched by opening a .mil file in the Windows Explorer
- Fixed: The Linux redirector was rewritten to be more friendly with the wininet library (Chunked data transfer mode is no longer used)
- Fixed: Various cosmetic bugs in the win32 and web client.

Bug fixes/Changes in v4.3.38 (18-Dec-2006)
- New: The DCOM protocol used to connect the eMill Client to the eMill Server was replaced with a much more flexible TCP/IP based socket protocol. A client may now therefore connect to an eMill server over the net.
- New: A new Start Page is now displayed once eMill is started.
- New: Call URL incoming rule action.
- New: It is now possible to insert values in the 'Move to folder' and 'Append to log' incoming rules (right click over the edit zone).
- New: A 'Delete All Records' option was added to the lists management.
- New: Possibility to add a column of type 'short integer' to a receivers list.
- New: EWC: Features that existed in the Win32 client but not in the Web client:
* Check email addresses feature
* Check duplicates feature
- New: VBScript Mail.Data property to set or retrieve the MIME content of a message.
- New: VBScript CreateUniqueID method that returns a 128 bit unique ID.
- Improved: The eMill setup now grants the \91modify\92 right to the 'Users' group inside the C:\WINDOWS\TEMP directory and inside the ODBC registry key to fix an ODBC Jet bug.
- Improved: The eMill setup now sets the rights to the installation folder ('Administrators' and 'system account' to full control, and 'Users' to read and execute).
- Improved: EWC: In the HTML text editor, the TAB key may be used when multiple lines are selected.
- Improved: The schedule may now be set by non admin users and the user interface was simplified. The schedule is still based on the system scheduler.
- Changed: The Contents icon was changed.
- Fixed: The eMill Win32 client could crash if a subject contained some badly formatted base64 encoding.
- Fixed: EWC: Tracking configuration was not displayed correctly if the first list was disabled.
- Fixed: A crash occurred when a script embedded within a content was removing itself.
- Fixed: Content ordering was no longer saved (regression).
- Fixed: An access denied error was causing the rendering to fail if the root folder of the eMill\pub drive did not have read right for the 'Users' group.
- Fixed: The HtmlToText method was not converting numeric entities (e.g. &#32;) and XHTML style <br/>.
- Fixed: Tracking statistics where lost if an exported field contained a . in its name. It could occur when the list query add a join.
- Fixed: The Subject field was not properly decoded from the MIME source when it was on multiple lines.
- Fixed: POP3 Incoming Queues to a Lotus Notes server could fail.
- Fixed: In some rare cases, project errors could not be flushed to project log if user that launched had limited rights.
- Fixed: EWC: The Optin/Optout feature generated rules that had the 'or' operator instead of the 'and' operator.
- Fixed: Non admin users no longer auto re register some required components (ADO, Triedt, etc.).
- Fixed: It was not possible to add a column to a list if the base table name contained a space char.
- Fixed: EWC: Excel lists were set to read only by default when created through the data source wizard.
    
Bug fixes/Changes in v4.2.37 (23-Oct-2006)
- Fixed: EWC: Importing into a receivers list has been simplified and some minor bugs were fixed.
- Fixed: EWC: Subfolders were not displayed after creating them.
- Fixed: EWC: Pressing the Enter key in the Duplicate mailing form was failing.
- Fixed: EWC: The list filtering feature was not working because of a regression.
- Fixed: EWC: The Delete All records from list feature was not working with MySQL and SQL Server.
- Fixed: EWC: It was not possible to add or display Excel lists.
- Fixed: EWC: The HTML editor hanged when an HTML tag started with two '<'.
- Fixed: EWC: 'No Fax List allowed' message when clicking on the OptIn option.
- Fixed: EWC: Microsoft Access receiver\92s lists were not closed properly.
- Fixed: EWC: Uploading a file greater than 20 MB in size was not possible.
- Fixed: EWC: In the tracking interface the 'does not contain' filter was not working.
- Fixed: EWC: The Import from unstructured text file was not capitalizing the first letter if the First name and Last name field.
- Fixed: EWC: The wrong list was selected when calling the preview from a receivers list.
- Fixed: Linear white spaces were not removed from decoded header fields (e.g. the subject field).
- Fixed: An error could occur when importing records in a MySQL table due to text truncation problem.
- Fixed: When an error occurred while importing records in a list, the temporary database was not always deleted.
- Fixed: The possibility to add a 'big integer' to a jet data source has been removed since jet does not support 64 bit integers.
- Fixed: Some columns were lost or column data was shifted when two fields in a list had the same name. Now duplicated names are prefixed by the original table name followed by a '.'.

Bug fixes/Changes in v4.2.36 (11-Oct-2006)
- Fixed: Crash when opening the project queues on Windows 2000.
- Fixed: When verifying addresses on a MySQL list and when a record was updated or deleted manually, a wrong record could be updated.

Bug fixes/Changes in v4.2.35 (26-Sep-2006)
- Added: EWC: Full SMS preview within virtual mobile phones.
- Fixed: MySQL connections were not correctly closed.
- Fixed: Accounting report values were not well interpreted.
- Fixed: Email addresses containing white spaces where not properly imported from Microsoft Excel files.
- Fixed: EWC: The incoming queue subscribe state was disabled when the project was saved.
- Fixed: EWC: The 'Insert link' feature in the HTML editor was not working.
- Fixed: EWC: Some Microsoft Access lists could display an error message when previewed.
- Fixed: EWC: MySQL lists did not display correctly when the Table/Query name after the FROM was not quoted.
- Fixed: EWC: Add/Remove list column worked only on Microsoft Access lists.
- Fixed: EWC: The popup email textbox disappeared when the user clicked on it.
- Fixed: EWC: The mailings were not correctly reloaded when the eMill server was restarted.

Bug fixes/Changes in v4.2.34 (8-Sep-2006)
- Added: EWC: Tab key support when selecting multiple text lines in the text editor.
- Added: EWC: Database import feature in the receivers and black list.
- Improved: EWC: The Html editor was refreshed to the latest version.
- Fixed: EWC: The project publish date was not displayed with the correct time zone.
- Fixed: EWC: Adding a record action rule with ADO Data source was not working properly.
- Fixed: EWC: Various cosmetic bugs.

Bug fixes/Changes in v4.1.33 (17-Jul-2006)
- New: HTTP rendering: This feature lets you import at render time static or dynamic web pages.
- New: eMill Service Provider Edition (Includes accounting features, private-labeled interface, security improvements and more).
- New: HIT_DATE server variable in Mailing_OnUrlClicked event (UTC date time).
- New: Ability to subscribe a mailing project to a queue that will receive all local DSNs generated by projects running in the same account.
- New: FormatEmailAddress and ExtractEmailAddresses AMS functions (See the scripting guide for details).
- New: Added 'Open project folder' option on the project root context menu (right click menu).
- New: Ability to import a web page into an existing HTML or to create a new content.
- New: Features that existed in the Win32 client but not in the Web client:
  * Added a 'Create a list for me' list type
  * Refresh button in the preview page
  * Add and Remove columns option on MS Access based lists
  * French language user interface
  * Xml Data Source Wizard. Allows access to eCommerce shops (osCommerce, OXID)
- Improved: The 'Accounts' security feature was completely redesigned to improve the web client versatility.
- Improved: Local images that are referenced in a <style> tag are now embedded to the MIME message.
- Improved: The 'Embed external images' option may now be used in conjunction with the 'Compress as Zip' option.
- Changed/Fixed: PDF print timeout extended to avoid errors when converting html that takes a long time to load (i.e.: html containing external images) - Changed: Text or HTML documents opened within eMill are now displayed in the shortcut bar.
- Changed: The 'Content is the message body' option is now a disposition option.
- Fixed: The 'Respond to incoming SMTP request' check box was never shown checked, even if the option was enabled.
- Fixed: Inactive projects are no longer kept opened during the eMill Server start-up process.
- Fixed: Changes made to records on a MySQL list are now visible. Before, changes were applied but not displayed.
- Fixed: A large project log no longer take ages to display.
- Fixed: Connection to an eMill server when installing an eMill client was failing if a specific account was used.
- Fixed: It was not possible to edit a sorted MySQL ODBC list.
- Fixed: Global script errors were not reported correctly in the web client.
- Fixed: If an error occurred in the global script while previewing, and if a global script list was used, this list was no longer working until the next refresh.
- Fixed: A project that had trailing spaces in it's name could not be published.
- Fixed: An invalid error message was displayed if a message rule condition/action data source could not be opened.
- Fixed: When running a multi language OS with eMill Pro, and if the client language was different than the system language, no mailings were displayed in the queues and forcing a refresh returned an Access Denied error.
- Fixed: In the message property dialog, the receiver status was only displayed for the first receiver.
- Fixed: Regression: The remove duplicates option was not disabled when using Excel data sources.
- Fixed: Changing an account security right was not reflected in the project files security.
- Fixed: It was not possible to sort a list on a column that is a joined field.
- Fixed: In some case, accented chars written in global script were not saved.
- Fixed: List filtering on date field always assumed that the time is 00:00:00 thus producing confusing result on date/time field comparison (for example: 12/02/2006 was not considered equal to a value like 12/02/2006 12:53:48).
- Fixed: Manual record deletion was not working in the address verification feature.
- Fixed: The Event Log is no longer polluted with POP3 queues errors. Errors are now only written once.
- Fixed: Miscellaneous cosmetic bugs.

Bug fixes/Changes in v4.0.32 (14-Feb-2006)

- New: A Web client was added.
- New: SMS channel through SMPP and tm4b.com.
- New: HTML form generator that implements double opt in management. eMill rules are also auto configured to handle subscribe and unsubscribe requests.
- New: Right click menu option to insert an unsubscribe link.
- New: Ability to subscribe to incoming queues in the Publish dialog.
- New: Ability to filter on specific DSN status codes (soft & hard bounces filtering).
- New: Rules modified on a published project are automatically updated to the local project when the project is published again. Rules are therefore no longer overwritten.
- New: XML Connector for eCommerce solutions (osCommerce and OXID).
- Improved: Toolbars initial locations are better organized.
- Improved: A Charset selection was added to the Content properties dialog.
- Improved: The Setup program was completely rewritten using a better technology. 
- Improved: Localization was improved. The Setup, samples and templates are now localized.
- Improved: Embedded images now have a filename attribute.
- Improved: List management improved to avoid slow reopening (e.g. in the List properties)
- Improved: The MySQL database is now accessed directly through ODBC and not through OLEDB. Doing this has solved a lot of crashes in the MyODBC driver and improved performances drastically.
- Improved: More charsets are supported (Windows-1252, Latin-9, etc.)
- Improved: The eMill win32 client now uses the eMill Server to send test messages. Messages are no longer sent locally.
- Changed: The 'Tracking' options can be saved even if validation has failed. This is useful when the public IP cannot be accessed from inside the LAN.
- Changed: Saving a content that is not compatible with the current code page no longer forces the utf-8 encoding.
- Fixed: Succeeded Fax DSNs were not formatted properly.
- Fixed: The script text output no longer trims spaces and CR LF after the %> tag. eMill now behaves exactly like .asp web pages (Active Server Page).
- Fixed: regression when setting Response.Charset, Response.CodePage was also modified.
- Fixed: The 'Outgoing Queues' properties where not entirely disabled when a user did not have modification rights.
- Fixed: The 'eMill Server' service crashed when starting a render and when the jet open threshold was already reached.
- Fixed: User could use the forward slash character in an an incoming queue name. This was causing a problem and caused the queue to disappear, the forward slash is no longer permitted.
- Fixed: The text editor could sometime load ASCII text as UTF-7 text.
- Fixed: eMill could not start if 'winfax.dll' was not present on the machine.
- Fixed: In the queues, folder that were not created manually did not appear automatically in the user interface (needed to press F5 to refresh).
- Fixed: The error line number in the content script was sometime invalid. 
- Fixed: The DSN condition was always reloaded with the 'Failed' action checked, even if it was saved unchecked.
- Fixed: If an account name had trailing spaces, projects published on this account were unavailable.
- Fixed: The eMill server is now accessible by XP SP2 non admin users.
- Fixed: DSNReturn and DSNNotify Mail properties were ignored by the mailer.
- Fixed: The DSN Mail properties were not reloaded in Mail_OnMailStatus.
- Fixed: In the Tracking general page, the send period restrictions was also restricting clicks and opens.
- Fixed: The 'Save message as' in the preview was not working in the French version.
- Fixed: eMill quoted FileMaker tables and fields incorrectly ( [name] instead of "name" ).
- Fixed: A POP3 incoming queue could stop working without reporting any error message to the Event Log.
- Fixed: Text editor content could be corrupted when pressing ctrl+right arrow on the last word of a line and then writing some text.
- Fixed: Some corrupted message store archives were not automatically repaired
- Fixed: The 'Tracking' item in the Queues was not always displayed
- Fixed: Client licenses are now validated
- Fixed: Miscellaneous cosmetic bugs.

Bug fixes/Changes in v3.3.31 (5-Jul-2005)
- Improved: Added automatic repair of ADO and MSHTML components
- Fixed: Regression since v3.3.30. Publishing a new project could return an Access denied error on some systems.
- Fixed: eMill could download the same message several times if the POP3 mail box had a lot of messages. POP3 sessions are now limited to 4000 messages and 1mn duration.
_ Changed: When adding a new Mail Content, and if the encoding property is not set, the default encoding is set to 'auto' instead of 'base64'
- Fixed: Importing email addresses from an unstructured text file did not always import the last address.
- Fixed: The HtmlToText method did not remove the 'mailto:' prefix for email link          
- Fixed: Temporary databases were not always deleted when cancelling the data source wizard.
- Fixed: When creating a new folder in the queues, some folder could appear multiple times.
- Fixed: Setting an html string to the Data property of a Mail Content did not automatically set the Type("charset") Content property...
- Fixed: Various cosmetic and minor bugs.

Bug fixes/Changes in v3.3.30 (13-Jun-2005)
- New: It is now possible to give a name to a tracked link.
- New: Two list filtering criteria have been added: 'is empty' and 'is not empty'.
- Improved: List filtering supports "any" option (operator or).
- Improved: It is now possible to close a project by right clicking on the project icon located in the shortcut bar
- Changed: The Reply-To message field is automatically removed from the message if it is the same as the From field.
- Changed: The 'Scripting Object Reference Cards' help page is now displayed by pressing F1 when editing the global script.
- Fixed: On some non-english systems, eMill could return an xml error when publishing or opening projects with a list based on Outlook contacts.
- Fixed: 'Open with' commands did not always launch the correct program.
- Fixed: 'Size' conditions where 'corrupted' when there was more than one 'Size' condition per incoming rule.
- Fixed: When importing an email, unsaved content modifications were lost.
- Fixed: {.FullName} merge field was not working correctly (last name was returned).
- Fixed: A crash occured when testing an incoming rule on a remotely published project. The test button is now disabled in this case.
- Fixed: When a list record update failed, all other attempts to modify a record were
         failing until the list was refreshed.
- Fixed: Adding a content with a '/' character in the name failed (unspecified error).
- Fixed: A crash could occur when too many tracking hit were processed.
- Fixed: Miscellaneous small bugs.

Bug fixes/Changes in v3.2.29 (14-Mar-2005)
- New: German language user interface for German speaking users
- New: Added a 'Check message size' condition to the incoming message processor.
- New: Added a 'Find value in header field/body field' to the incoming message processor condition.
- Changed: The 'Redirect message' action has been renamed to 'Forward message'
- Fixed: Double clicking on a .mil file in the Windows Explorer did not always launch eMill.
- Fixed: Messages were retried one less time than the retry count specified in the project properties.
- Fixed: Setting a CRLF in a header field using AMS was corrupting the message
- Fixed: A crash could occur when removing an outgoing queue.
- Fixed: If a project name was not compatible with current machine code page, the project could not be published.
- Fixed: Attempting to set a read only property of an AMS object did not always report an error.

Bug fixes/Changes in v3.1.28 (26-Jan-2005)
- New: It is now possible to send and receive faxes within eMill.
- New: You can now easily set filtering criterias on your lists (no SQL knowledge required).
- New: The incoming message processor now offers the possibility to read fields in the message body (e.g. for reading fields created by a web form)
- New: It is now possible to customize mail headers (Subject, Reply-To, etc.) without inserting script. Right click over a header field to insert a data source field.
- New: List records can now be sorted by clicking on the column field title.
- New: An \91Open Samples\92 menu option was added to the File menu.
- Changed: When redirecting an incoming message, the original received message is now left in the Inbox. 
- Changed: The Errors-To field was removed because this field is not used by SMTP servers. The SMTP Sender field is the one that is used to return DSN messages.
- Improved: The 'Insert fields' dialog is now available in the Global Script editor.
- Improved: It is possible to select multiple projects in the Queues window.
- Improved: The Outgoing Queues dialog was completely redesigned.
- Improved: The quoted-printable encoding is now 100% compliant with the RFC2045.
- Improved: Added support for MySQL version 4 and later.
- Fixed: The 'begins with' incoming message processor condition was not working. 
- Fixed: The S/MIME encryption was not working properly
- Fixed: Empty mail archives (.dat files) were not always automatically deleted.
- Fixed: The message tracking was not working if the collect user name or password contained one of the following characters: \ / @ 
- Fixed: Images path in HTML contents were not processed correctly if they used backslashes.
- Fixed: VB Script files (.vbs) were only rendered if the Content-Type was set to text/*
- Fixed: Server properties are no longer displayed on eMill clients.
- Fixed: The preview mode no longer removes background color and margins from HTML contents.
- Fixed: The Original-Envelope-ID field was missing in locally created DSNs.
- Fixed: If a data source had a trailing space in one of its fields, the project could not be published.
- Fixed: Regression since v3.0.26, the render was failing with a black list error 'File not found' or 'Access is denied' when a SQL Server or CSV black list was used.
- Fixed: Crash occurred when adding a content including a quote in the name.
- Fixed: Regression since v3.0.26, global script events were not called when testing the incoming message rules.
- Fixed: The Response.Write function was not replacing the %/> with %>
- Fixed: Various cosmetic and minor bugs.

Bug fixes/Changes in v3.0.27 (18-Oct-2004)
- Fixed: A server crash could occur when the tracking was enabled and a lot of hits were being processed.
- Fixed: A server crash could occur during sending on multiprocessor or hyper threaded systems.
- Fixed: The Windows Address Book data provider was not working on a freshly installed Windows 2000 installation.
- Fixed: The 'Open With' command was not working in the receivers list view.
- Fixed: Mailer statistics could be reset by users that did not have 'Write' rights.
- Fixed: Tracking statistics where unavailable for an entire account if a projet had a '&' char in its name.
- Fixed: The incoming message processor priority condition was not working properly (priority was inverted).
- Fixed: The HTML could get corrupted when inserting a double quote (") in the alternate text tag.
- Fixed: When saving a newly created html document, the default file name in the Save As dialog looked like: "HTML.htm;*.html;*.shtml;*.asp".
- Fixed: Email address that contained an ampersand (before the '@') were not correctly recorded in the message tracking database.
- Fixed: The preview was not displaying attachment names properly if special characters were used.
- Fixed: Black list changes were not always reflected in the receivers list.
- Fixed: Import mail was grayed since v3.0.
- Fixed: Previewing the last receiver with an access datasource (count > ~1000) could generate an error.
- Fixed: The HTML was not loading properly if the &quot; entity was used in a quoted attribute.
- Fixed: In the insert image dialog, the cursor was always moved to the last char when editing the image file name field.
- Changed: When they are more than 100 folders in a project queue, the Move Message menu is now limited to the root folders and a Move Messages dialog was added.
- Changed: The receiver list limit license restriction was increased in all versions. See the eMill pricing for details.
- Changed: The message store database recovery process is no longer done during the eMill Server service startup.

Bug fixes/New features in v3.0.26 (26-Jul-2004)
- New: When opening a project in design mode, the project structure is represented as a tree. This makes eMill easier to use and learn.
- New: Added a 'Condition' tab to the 'Content Properties' settings that let you enable or disable a content based on condition with the current record. (e.g. If 'Language' is 'English', If 'PreferredFormat' is 'HTML' etc. ).
- New: The locale identifier (LCID) can now be set in the content and project properties. This feature is useful to specify how a date will be formatted and in what language it will be written.
- New: Added a 'Embed external images' option to the 'Content Properties' settings. This feature is useful if you want to embed in the MIME message images that are stored on a web site.
- New: It is now possible to enable multiple receivers list for a single project. 
- New: Record fields are now trimmed by default. Some databases such as dBase and FoxPro can return text fields with untrimmed spaces. These spaces are now automatically trimmed.
- New: Added a 'Mailing_OnUrlClicked' event that can be used to store tracking events in your own database.
- New: Added a global setting that will let you force encoding of special characters to their html entities equivalent.
- New: It is now possible to send secure messages (S/MIME). Messages can be signed and/or encrypted.
- Improved: eMill Server can now connect to the eMill Redirector using basic authentication. This can be useful with some firewall which may prevent using the NTLM authentication.
- Improved: The Record.Update method may now be used during the rendering process to update a record value.
- Improved: The Queues were very slow if a project had lots of sub folders (thousands).
- Improved: eMill automatically closes databases when they are not accessed for a long time. It reduces significantly the overall memory usage and reduces the problem of Jet that is limited to 64 simultaneous databases opened per process.
- Improved: The global script editor is now based on the standard text editor making it easier to use and less restrictive. 
- Improved: The 'Add Attachment' file dialog allows adding multiple files at once.
- Improved: The 'Verify Addresses' feature is now much faster (up to 40 times faster!).
- Improved: The 'Preview' has been completely redesigned (tree view, hex view, per content source view, etc.).
- Improved: The project tool bar is now scrollable, shows more text and has tool tips.
- Improved: All flavors of Unicode files are recognized.
- Improved: Performances on multi processor machines have been significantly improved.
- Changed: The eMill Server service will no longer be prevented from starting if an outgoing SMTP queue cannot be opened.
- Fixed: The global script was not automatically reloaded when it was changed with an external editor.
- Fixed: Email address validation is more accurate to the RFC specifications.
- Fixed: Mailing sub folders could not be displayed if the folder name included a < or > character.
- Fixed: The 'Export List' feature was not working on non-French or US-English systems.
- Fixed: Various cosmetic and server crashes.

Bug fixes in v2.5.24b (23-Jan-2004) 
- Improved: Added an "Is Empty" and "Is Not Empty" choice to message tracking header condition
- Fixed: The eMill Outlook data provider was not compatible with Outlook 2003
- Fixed: Data source access errors were often reported as "Unspecified error"
- Fixed: Improved HTML parsing, client scripts not enclosed by comment markup are now correctly handled
- Fixed: The Apply button was not always enabled on changes in the message filtering property page
- Fixed: Text contents could be loaded with the wrong charset...
- Fixed: Render returned access denied with PDF conversion when a non-admin user started the render.
- Fixed: A memory leak could occur when attaching Unicode text file to the mail
- Fixed: The Total received messages in the mailer statistics was always set to 0
- Fixed: Creating an account returned a invalid "File not found" error however the account was successfully created.
- Fixed: Tracking settings did not worked properly with an empty password. Empty passwords are now forbidden.
- Fixed: Hyperlinks had too many chars escaped by the HTML editor (regression)
- Fixed: Mail.Save had a memory leak if an error occurred (locked file, etc.).
- Fixed: Message processor update record action did not work properly with some ODBC connections
- Fixed: translations issues, missing strings, help errors, etc.
- Fixed: The eMill Redirector could be installed in a wrong directory and then the redirector snapin failed to activate the tracking with first a "File not found" followed by a "File exists" error.
- Fixed: Crash when editing long lines of script in the text editor
- Fixed: The "Duplicate Project As" command did not include unsaved project changes 

Bug fixes in v2.5.23 (22-Oct-2003) 
- Fixed: The 'Import from unstructured text file' wizard was not working (Next button had no effect)
- Fixed: Copying and Pasting a script from an HTML content to another was not working properly
- Fixed: The Mail.Priority property could not be set to 2 or 4 
- Fixed: The message tracking activation wizard was not working when used remotely
- Fixed: The Mail.AbortRender method was no longer working (regression)
- Fixed: The eMill Server service could not always be stopped when running on Windows NT 4.0 

New features/Bug fixes in v2.5.22 (1-Oct-2003) 
- Added: Wizard based incoming message processor
- Added: 'Redirect' command in the project Queues to forward message(s) to a specific email address
- Added: 'Reprocess' command in the project Queues to re inject a received message through the incoming processor
- Added: Registry entry to specify the 'pub' folder location. (HKLM\Software\Active+\eMill:PubDir)
- Added: Mail.Save method to save the Mail object as an eml file. 
- Improved: The message store is now much more robust. Corrupted files are automatically repaired.
- Improved: The Server object is now available in all script contexts
- Improved: Modifications made on the Mail object in the Mail_OnEndRender are now saved
- Improved: CreateMail and SubmitMail can now be called in the OnMailStatus event
- Improved: POP3 incoming queues are much faster and more reliable
- Improved: SMTP mailer is faster and more reliable. Messages are only aborted on permanent failures (user unknown, mailbox full, etc.).
- Improved: Render statistics are updated all the time and not only when the render process has completed
- Fixed: Under Windows 2000, the eMill Server service was often reported has hanged when in fact it was really started.
- Fixed: The date & time of a published project was displayed in UTC time and not local time.
- Fixed: The tracking redirector was not installing on a PDC
- Fixed: A crash could occur when receiving a mail with malformed base64 encoding
- Fixed: URLs were not encoded properly if they contained the inferior '<' character
- Fixed: If a script was included in the HTML title, the script was lost
- Fixed: A crash could occur the the href property was beginning with a space 
- Fixed: Malformed DSN messages could crash eMill
- Fixed: Converting a content to the PDF or ZIP format no longer changes the content position
- Fixed: The Schedule feature was not working if the remote eMill server has a different %SYSTEMROOT% path
- Fixed: After sometime POP3 queues were no longer working and large amounts of memory were not released

New features/Bug fixes in v2.4.21 (30-May-2003) 
- New: Scripts and inserted fields are now displayed in the HTML editor (instead of just <%...%>) 
- New: Receivers that are listed in a project queue folder can be exported to a .csv file
- Improved: When refreshing the data view, columns widths are not reset to the default size
- Fixed: Login/password was displayed when opening the tracking window
- Fixed: Crash when calling Mailing.SubmitMail on a tracked project
- Fixed: Project file (.mil) was sometime corrupted with garbage data at the end of the xml data
- Fixed: The database export feature supports more data types (eMill now works with the Exchange Server mapidata provider)
- Fixed: When changing some project properties on a published project, the subscribed incoming queue list was emptied if the "Incoming queues" tab was never clicked
- Fixed: Html source code is less messed up

Bug fixes in v2.3.20 (16-Avr-2003) 
- Fixed: When rendering, HtmlToText could lock the server 
- Fixed: Browser control sometime failed to load text
- Fixed: Previewing after changing some script no longer reset the current position to 1
- Fixed: The schedule feature could display "RPC server not available" error message
- Fixed: Setting Mail.DSNEnvID had no effect. The EnvID was not passed during the ESMTP session
- Fixed: 'Access Denied' error displayed when removing a published project (Pro version only)

New features/Bug fixes in v2.3.19 (20-Mar-2003) 
- Added a message tracking feature to the enterprise edition
- Added support for Act! 6
- Added integration with HTML editors (Dreamweaver, FrontPage, Visual Studio, etc.)
- Added support for XP visual themes
- Improved message store: Messages now use up to 80% less disk space and messages are stored in archive files instead of individual files.
- Improved mailer performance with large mailings (CPU usage was very high)
- Improved bounce messages processor (supports more formats and recover non standard DSN)
- Improved server events handling: The script now remains loaded between each event
- Fixed: various problems when running with non admin rights (samples not copied, splash screen stayed opened because an error was displayed behind it)
- Fixed: an invalid error was reported to the event log if an incoming queue was set to an empty directory
- Fixed: SMTP mailer was not setting the ORCPT ESMTP parameter properly. The ORCPT was set with the wrong email address.
- Fixed: If the content name was renamed, the change was not saved to the project file
- Fixed: crash occurred when publishing a project and no server was previously configured
- Fixed: server crash could occur when publishing over a project that was being rendered
- Fixed: crash occurred when importing some eml files
- Fixed: Scheduling feature was not working if the project name contained a space
- Misc cosmetics and minor fixes (accelerator, menus, etc.)

Bug fixes in v2.2.18 (14-Fev-2003)
- Corrected problem in setup program when installing a client without the server (eMill disappeared from the screen)
- Corrected problem when importing Outlook contacts (file not found error)

New features/Bug fixes in v2.2.17 (6-Dec-2002) 
- Added native support and connection wizard for MySQL databases
- Added ability to connect to a remote eMill Server over a VPN connection
- Added Back, Next and Home toolbar button for easier navigation in the Preview 
- Added render stats to the project statistics
- Improved render speed by up to 35%
- Crash could occur when modifying project properties created with a previous eMill version
- Export could fail due to an incompatible field type when using a SQL Server database
- Retry was not available when an error occurred on Publish (ex.: file locked)
- Content editor can be configured to open the HTML in source mode
- Server side script properties window is now resizable
- Mailing.CreateMail now works with empty parameters
- Mailing.CreateMail can create a mail based on a RFC822 content stored in a Content Object.
- Server.ScriptTimeout was not working (setting the property had no effect)
- The Mailer could stop sending mails if the next message to send was deleted.
- New empty project was not working properly because of an invalid path problem (files created on root)
- Added Multi-user selection to the "Add user or group" dialog 
- Server crash could occur if a render was aborted while the server was in an alterable state
- Back slash (\) were not encoded and decoded properly in the MIME header 
- Misc cosmetics and minor fixes (accelerator, menus, etc.)

New features/Bug fixes in v2.1.16 (26-Aug-2002) 
- Added X-Href-Prefix & X-Href-Suffix headers to the Content.Headers collection
- Corrected regression with text editor shortcuts. Some shortcuts were no longer working...
- Corrected data source problem when first receivers email address was empty or null.

New features/Bug fixes in v2.1.15 (19-Aug-2002) 
- It is now possible to save predefined data source settings (query, db, etc.)
- Added support for RFC1891 and RFC1894
- Improved MIME encoder to support Exchange Server / Outlook 2000 configurations
- Corrected a problem with some Outlook 2000 configurations (a "No interface" error was displayed)
- Corrected a problem on .Net Server when saving the project codepage setting 

New features/Bug fixes in v2.0.14 (17-Jul-2002) 
- Corrected setup problem with msxml (msxml2.dll was not installed)
- Corrected problem with mailer backup settings (sent message were not saved)
- Corrected problem with Global script editor on Windows NT 4.0

New features/Bug fixes in v2.0.13 (8-Jul-2002) 
- Corrected problem in demo version with some Outlook clients (Outlook was showing the note as an attachment)
- Moved MFC updates to the eMill\bin directory
- Corrected problem with help files

New features/Bug fixes in v2.0.12 (28-Jun-2002 - Microsoft TechEd release) 
- Added french help file
- Global script editor now accepts Unicode characters, script file may be saved in UTF-8 and Unicode
- Schedule was not working if the project named contained a dot
- Response.AddHeader was not working
- HTML embedded contents (gif, etc.) were not zipped with a correct name
- Database was not published if both the Receivers and Blacklist data sources were exported
- eMill Server crash corrected on multi processor system
- Data Source Export was not working properly with some field type
- Render was not aborted if a content script was failing
- Correct problem when linking to non English Act! 2000 Databases

New features/Bug fixes in v2.0.11 (07-Jun-2002) 
- New data source type added: Microsoft Outlook Contacts, Windows Address Book and ACT! 2000
- New black list feature (the black list contains email addresses that should never receive any mail)
- New Import and Export data source feature
- New Remove Duplicates feature
- Database fields can be added and removed directly from eMill (works with most data source)
- Data source can be changed in an existing project using the data source wizard 
- New "Compress as ZIP" content Properties. Any eMill content can be sent as a zip attachment
- New multi users architecture with support for native NT security, quotas and accounting
- Full client/server architecture (users from the LAN can access remote eMill Servers)
- New XML Server interface for greater interoperability with other applications
- New message store, performance where improved dramatically on very large mailings
- DNS performance where greatly improved (support for Active+ DNS Web Service)
- eMill Server can work even if the machine is not connected to the Internet
- Completely redesigned the Queue user interface. The interface now supports sub folders and user accounts
- Added POP3 login authentication to the Outgoing SMTP Queues
- Error reporting where was greatly improved. All server errors are now reported to the mailing log
- Improved multi language support (PDF encoder supports multi-bytes characters, Text editor can read UTF-8 files)
- New French version

Bug fixes in v1.0.10 (10-May-2002)
- Mailing_OnMailStatus was never called

Bug fixes in v1.0.9 (05-Apr-2002)
- Queue did not show the correct time when daylight saving time is active

Bug fixes/changes in v1.0.8 (08-Mar-2002)
- Rendering a project with an Excel data source was not working if the Excel file was opened by another ADO connection
- Converting a content to PDF was not working with IE6 if the PDF print driver was not the default printer
- The rendering process now runs within the security context of the eMill Client
- Rendering errors are appended to the mailing project log.txt file

Bug fixes in v1.0.7 (22-Feb-2002)
- Creating a new project in the Professional version was not working if an ADO connect string was not specified.
- The Preview was reseting the "Content Not Saved" internal flag resulting in data not beeing saved when closing or publishing a project.

Bug fixes in v1.0.6 (7-Jan-2002)
- Editing the script through the script dialog was not working
- In the Queue, Folders statistics sometime showed negative numbers
- Setting the mailing priority to high or highest was in fact setting the priority to low.

Bug fixes in v1.0.5 (first public release, 28-Dec-2001):
- Delete mailing while rendering caused a dead lock in eMill Server.
- Publish mailing while mailer is sending caused a dead lock in eMill Server.
- Importing an eml file with attachments that used file names with spaces was not working.
- Script executed through Server.Execute can now be debugged.
- When a script error occurs, the script editor cursor will be positionned to the line where a problem was encountered.
- The X-Sender field is now set by Mailing.SubmitMail.
- Added statistical information regarding incoming mails.
- Added a Primary key to default Access database.
- Changed installer software from Wise to InstallShield
- Other minor Bug fixes...

Bug fixes in v1.0.4:
- eMill was closing the active window when pressing OK in the "Options" dialog.
- The Receivers collection was not loaded on incoming messages.
- The Date displayed in the queue is now the file date and not the MIME header date.
- BMP files were not displayed correctly in an HTML content.
- Modifying the content properties did not always work properly.
- Added ASP file to the file open dialog selection.
- ASP content is now recognized as scriptable HTML content.
- HTML content that included links to other contents could produce an incorrect MIME file.
- In some situation, a MIME end boundary marker was found several times, causing images not to be displayed properly in some email clients.
- HTML/CID parsing did not work when HTML attributes included spaces.
- Various others cosmetic bugs corrected.

Bug fixes in v1.0.3:
- The detected DNS server IP was not correct

Bug fixes in v1.0.2 (first beta release):
- Charsets were lost during mail rendering.
- The text editor supports UNICODE files.
- The text editor can load and save MBCS text with the current code page if the text is compatible with this code page. Unicode format is used if some text is not in the current code page.
- The text and HTML editors are now fully UNICODE compatible.
- Stopping the eMill Server while the queue window is open no longer crashes it.
- The "server busy" dialog box is no longer displayed when the server no longer responds to RPCs. Instead, an Error MessageBox is displayed and the server connection is closed.
- Improved HTML parsing (search for relative path).
- Added direct access to ADO (improves render performance up to 25%).
- Added a "GoTo Line" dialog box to the text editor.
- Pausing a Render no longer uses 100% of CPU time.
- Stopping a render and instructing to delete messages now works.
- Tab key in the text editors indented line even if there wasn't any selection - Fixed.
- "Delete all" in the queue no longer asks confirmation after all messages were deleted.
- HTML content-type meta tag is set to the attachment content-type property.
- Double-click on an image or script in HTML editor opens the Properties dialog.
- With IE v5.5 and later, the "<% %>" image can no longer be resized.
- Response.LCID now works.
- The import mail feature was crashing (infinite loop) with badly formatted eml files - Fixed.
- After using the "Add Content from File" feature. The content was not the project file but the original file instead - Fixed.
- A MailingList sample that handles incoming messages to implement commands like SUBSCRIBE and UNSUBSCRIBE was added.
- Problem with the eMill PDF Converter was fixed. It was causing the Print Spooler service to crash when the service was starting on a system boot.
- The UTC time adjustment was not computed correctly. The time was always in daylight saving time.
